<?
define("SAFE_MODE", 0);
define("DEBUG", 1);
$DBHOST="mysql";
error_reporting(0);

function NotAuthorized() {
  Header("HTTP/1.0 401 Unauthorized");
  Header("WWW-authenticate: basic realm=\"PHP Wizard\"");
}

function getpwnam($user) {
  $fp = fopen("../../.phpwizard", "r");
  if ($fp):
    while ($str = fgets($fp, 100)):
      $str = chop($str);
      if (ereg("^$user:", $str)):
        return $str;
      endif;
    endwhile;
  endif;
  return "";
}

function PrintHead($title = "") {
?>
<HTML>
<HEAD>
<TITLE>
PHP Database Wizard: <?echo $title?>
</TITLE>
</HEAD>
<BODY BGCOLOR="#B1CEF7">
<H1 ALIGN="CENTER">PHP Database Wizard: <?echo $title?></H1>
<?
}

function PrintFoot($str = "") {
  echo $str;
?>
  <P ALIGN="CENTER">
  <A HREF="<?echo $PHP_SELF;?>">Return to Start</A>
  </P>
  </BODY>
  </HTML>
<?
}

function NotAvailable($file = "", $line = 0) {
  PrintHead("Not available");
  if ($line):
    echo "<H2>Error at $file:$line</H2>\n";
  endif;
  PrintFoot();
}

function FormStart() {
  Global $PHP_SELF;
  Global $DB;
  Global $TABLE;
  Global $SQL;
  Global $VIEW;
  Global $PAGESIZE;
  Global $IDFIELD;
  Global $IDTYPE;
  Global $FIELDS;
  Global $FIELDNAMES;
  Global $CAPTIONS;
  Global $OPTIONS;
  Global $OPTIONS1;
  Global $OPTIONS2;
  Global $CONTROLS;
?>
  <FORM ACTION="<?echo $PHP_SELF;?>" METHOD="POST">
<?
  if ($DB):
?>
    <INPUT TYPE="HIDDEN" NAME="DB" VALUE="<?echo $DB;?>">
<?
  endif;
  if ($TABLE):
?>
    <INPUT TYPE="HIDDEN" NAME="TABLE" VALUE="<?echo $TABLE;?>">
<?
  endif;
  if ($SQL):
?>
    <INPUT TYPE="HIDDEN" NAME="SQL" VALUE="<?echo HtmlSpecialChars($SQL);?>">
<?
  endif;
  if ($VIEW):
?>
    <INPUT TYPE="HIDDEN" NAME="VIEW" VALUE="<?echo $VIEW;?>">
<?
  endif;
  if ($PAGESIZE):
?>
    <INPUT TYPE="HIDDEN" NAME="PAGESIZE" VALUE="<?echo $PAGESIZE;?>">
<?
  endif;
  if ($IDFIELD):
?>
    <INPUT TYPE="HIDDEN" NAME="IDFIELD" VALUE="<?echo $IDFIELD;?>">
<?
  endif;
  if ($IDTYPE):
?>
    <INPUT TYPE="HIDDEN" NAME="IDTYPE" VALUE="<?echo $IDTYPE;?>">
<?
  endif;
  $i = 0;
  while ($i < count($FIELDS)):
?>
    <INPUT TYPE="HIDDEN" NAME="FIELDS[]" VALUE="<?echo $FIELDS[$i];?>">
<?
    $i++;
  endwhile;
  $i = 0;
  while ($i < count($FIELDNAMES)):
?>
    <INPUT TYPE="HIDDEN" NAME="FIELDNAMES[]" VALUE="<?echo $FIELDNAMES[$i];?>">
<?
    $i++;
  endwhile;
  $i = 0;
  while ($i < count($CONTROLS)):
?>
    <INPUT TYPE="HIDDEN" NAME="CONTROLS[]" VALUE="<?echo $CONTROLS[$i];?>">
<?
    $i++;
  endwhile;
  while (list($key, $val) = each($OPTIONS)):
?>
    <INPUT TYPE="HIDDEN" NAME="OPTIONS[<?echo $key;?>]" VALUE="<?echo HtmlSpecialChars($val);?>">
<?
  endwhile;
  while (list($key, $val) = each($OPTIONS1)):
?>
    <INPUT TYPE="HIDDEN" NAME="OPTIONS1[<?echo $key;?>]" VALUE="<?echo HtmlSpecialChars($val);?>">
<?
  endwhile;
  while (list($key, $val) = each($OPTIONS2)):
?>
    <INPUT TYPE="HIDDEN" NAME="OPTIONS2[<?echo $key;?>]" VALUE="<?echo HtmlSpecialChars($val);?>">
<?
  endwhile;
  $i = 0;
  while ($i < count($CAPTIONS)):
?>
    <INPUT TYPE="HIDDEN" NAME="CAPTIONS[]" VALUE="<?echo $CAPTIONS[$i];?>">
<?
    $i++;
  endwhile;
} // FormStart

function FormEnd($str = "", $noreset = 0) {
  if ("$str" != ""):
?>
    <INPUT TYPE="SUBMIT" NAME="cmd" VALUE="<?echo $str;?>">
<?
    if (!$noreset):
?>
      <INPUT TYPE="RESET">
<?
    endif;
  endif;
?>
  </FORM>
<?
} // FormEnd

function PrintSqlInput() {
  Global $SQL;
  FormStart();
?>
  <TABLE CELLPADDING=5 CELLSPACING=0>
  <TR VALIGN="TOP">
  <TH NOWRAP ALIGN="RIGHT"><FONT SIZE="+1">SQL:</FONT>&nbsp;&nbsp;SELECT</TH>
  <TD><TEXTAREA NAME="SQL" ROWS=3 COLS=60 WRAP="VIRTUAL" 
  TITLE="Type your SQL here"><?echo $SQL;?></TEXTAREA></TD>
  </TR></TABLE>
<?
  FormEnd("Select SQL");
} // PrintSqlInput

if(!$PHP_AUTH_USER):
  NotAuthorized();
  exit;
else:
//  $VALID_USERS = " nmark mvl ise ";
//  $TMP_USER = " $PHP_AUTH_USER ";
//  if (!ereg($TMP_USER, $VALID_USERS)):
//    NotAuthorized();
//    exit;
//  endif;
  $pw = getpwnam($PHP_AUTH_USER);
  if (!$pw):
    NotAuthorized();
    exit;
  endif;
  $login = strtok($pw, ":");
  $passwd = strtok(":");
  if (crypt($PHP_AUTH_PW, substr($passwd, 0, 2)) != $passwd):
    NotAuthorized();
    exit;
  endif;
endif;

if (!mysql_pconnect($DBHOST)):
  NotAvailable();
  exit;
endif;
if (!$DB): // No database selected yet
  $dbs = mysql_list_dbs();
  if (!$dbs):
    NotAvailable();
    exit;
  endif;
  $num_dbs = mysql_num_rows($dbs);
  if (!num_dbs):
    NotAvailable();
    exit;
  endif;
  PrintHead("Select Database");
  FormStart();
  echo "<CENTER>\n";
  echo "<SELECT NAME=\"DB\">\n";
  $i = 0;
  while ($i < $num_dbs):
    $dbname = mysql_dbname($dbs, $i);
    echo "<OPTION>$dbname\n";//</OPTION>\n";
    $i++;
  endwhile;
  echo "</SELECT><BR><BR>\n";
  FormEnd("Select DB");
  echo "</CENTER>\n";
  PrintFoot();
elseif ("$cmd" == "Select DB"): //Database selected in $DB variable
  if (!mysql_select_db($DB)):
    NotAvailable(__FILE__, __LINE__ . "<BR>" . mysql_error());
    exit;
  endif;
  $tables = mysql_list_tables($DB);
  if (!$tables):
    NotAvailable(__FILE__, __LINE__);
    exit;
  endif;
  PrintHead("Type in SQL or select table");
  PrintSqlInput();
  echo "<BR>\n";
  FormStart();
?>
  <SELECT NAME="TABLE">
<?
  $tables_num = mysql_num_rows($tables);
  $i = 0;
  while ($i < $tables_num):
    $table_name = mysql_tablename ($tables, $i);
    echo "<OPTION>$table_name\n";
    $i++;
  endwhile;
  mysql_free_result($tables);
?>
  </SELECT>
<?
  FormEnd("Select Table", 1);
  PrintFoot();
elseif ("$cmd" == "Select SQL" || "$cmd" == "Table View"): // Preview SQL output format
  if (Trim($SQL) == ""): // Just forgot SQL
    PrintHead("Type in SQL please");
    PrintSqlInput();
    PrintFoot();
  else: // We have SQL expression here
    if (!mysql_select_db($DB)):
      NotAvailable(__FILE__, __LINE__);
      exit;
    endif;
    $SQL = stripslashes($SQL);
    if (!eregi("LIMIT", $SQL)):
      $LSQL = "$SQL LIMIT 1";  // Prevent huge results transfer
    else:
      $LSQL = $SQL;
    endif;
    $result = mysql_query("SELECT $LSQL");
    if (!$result):
      PrintHead("Please correct your SQL");
      echo "<B>The error was:</B> ";
      echo "<TT>" . mysql_error() . "</TT>\n";
      PrintSqlInput();
      PrintFoot();
    else: // SQL parse ok
      $fields = mysql_list_fields($result);
      PrintHead("Select Fields to Show");
      FormStart();
?>
      <H3>SQL: 'SELECT <?echo $SQL;?>'</H3>
      <CENTER>
      <TABLE BORDER=1 CELLSPACING=1 CELLPADDING="3">
      <TR><TH>Column</TH><TH>Table</TH><TH>Size</TH><TH>Null</TH>
      <TH>Key</TH><TH>Type</TH><TH>Show as</TH><TH>Caption / Name</TH></TR>
<?
      while ($field = mysql_fetch_field($result)):
        $name = $field->name;
        $table = $field->table;
        $maxlength = $field->max_length;
        $null = $field->not_null ? "No" : "Yes";
        $keytype = "&nbsp;";
        if ($field->primary_key):
          $keytype = "Pri";
        elseif ($field->unique_key):
          $keytype = "Uni";
        elseif ($field->multiple_key):
          $keytype = "Mul";
        endif;
        $type = $field->type;
        echo "<TR><TD>$name</TD><TD>$table</TD><TD>$maxlength</TD>";
        echo "<TD>$null</TD><TD>$keytype</TD><TD>$type</TD>";
?>
        <TD>
        <SELECT NAME="FIELDS[]">
        <OPTION VALUE="Dont">Dont show
        <OPTION VALUE="Hidden">Hidden Input
        <OPTION SELECTED>Text
        <OPTION>Picture
        <OPTION>Input
        <OPTION>Email
        <OPTION>URL
        </SELECT>
        <TD><INPUT TYPE="Text" CHECKED SIZE=10 NAME="CAPTIONS[]" VALUE="<?echo $name;?>"></TD>
        <INPUT TYPE="Hidden" NAME="FIELDNAMES[]" VALUE="<?echo $name;?>">
        </TR>
<?
      endwhile;
?>
      </TABLE>
      <BR>
      <TABLE CELLPADDING=4 CELLSPACING=".">
      <TR>
      <TH ALIGN="RIGHT">Show results as:</TH>
      <TD>
      <INPUT TYPE="Radio" NAME="VIEW" VALUE="table" CHECKED>Table
      <INPUT TYPE="Radio" NAME="VIEW" VALUE="list">UL
      <INPUT TYPE="Radio" NAME="VIEW" VALUE="records">Separated Records
      </TD>
      </TR>
<?
      if (!eregi("LIMIT", $SQL)):
?>
        <TR>
        <TH ALIGN="RIGHT">Records per screen:</TH>
        <TD><INPUT TYPE="Text" NAME="PAGESIZE" VALUE="20" SIZE=8></TD>
        </TR>
<?
      endif;
?>
      </TABLE>
      <BR>
      <BR>
<?
      FormEnd("Proceed with selected");
      echo "</CENTER>\n";
    endif;
  endif;
elseif ("$cmd" == "Proceed with selected"): // We have SQL and view type here
  PrintHead("Preview");
  $SQL = stripslashes($SQL);
  echo "<H3>SQL: 'SELECT $SQL'</H3>\n";
  if (!mysql_select_db($DB)):
    NotAvailable(__FILE__, __LINE__);
    exit;
  endif;
  $HasLimit = eregi("LIMIT", $SQL);
  if (!$HasLimit):
    $LSQL = "SELECT $SQL LIMIT $PAGESIZE";  // Prevent huge results transfer
  endif;
  $result = mysql_query($LSQL);
  if ("$VIEW" == "table"):
?>
    <TABLE WIDTH="100%" BORDER=1 CELLPADDING=2 CELLSPACING=1>
    <TR VALIGN="TOP">
<?
    $i = 0;
    while ($i < count($FIELDS)):
      if ($FIELDS[$i] != "Dont" && $FIELDS[$i] != "Hidden"):
        echo "<TH>";
        echo $CAPTIONS[$i];
        echo "</TH>";
      endif;
      $i++;
    endwhile;
?>
    </TR>
<?
    $RecStart = "<TR VALIGN=\"TOP\">";
    $RecEnd = "</TR>\n";
    $FieldStart = "<TD>";
    $FieldEnd = "</TD>";
  elseif ("$VIEW" == "list"):
    echo "<UL>";
    $RecStart = "<LI>";
    $RecEnd = "</LI>\n";
    $FieldStart = "";
    $FieldEnd = ";";
  elseif ("$VIEW" == "records"):
    $RecStart = "";
    $RecEnd = "<HR>\n";
    $FieldStart = "Caption:";
    $FieldEnd = "<BR>\n";
  endif;
  while ($row = mysql_fetch_row($result)):
    echo $RecStart;
    $i = 0;
    while ($i < count($row)):
      $val = $row[$i];
      $caption = $CAPTIONS[$i];
      switch ($FIELDS[$i]):
        case "Dont":
          break;
        case "Hidden":  // Don't use any separators here
?>
          <INPUT TYPE="Hidden" NAME="<?echo $caption;?>" VALUE="<?echo $val;?>">
<?
          break;
        case "Picture":
          if ("$FieldStart" == "Caption:"):
            echo "<B>$caption:</B>";
          else:
            echo $FieldStart;
          endif;
?>
          <IMG SRC="<?echo $val;?>" BORDER=0 ALT="<?echo $caption;?>">
<?
          echo $FieldEnd;
          break;
        case "URL":
          if ("$FieldStart" == "Caption:"):
            echo "<B>$caption:</B>";
          else:
            echo $FieldStart;
          endif;
          if ($val):
?>
            <A HREF="<?echo $val;?>"><?echo $caption;?></A>
<?
          else:
            echo "&nbsp;";
          endif;
          echo $FieldEnd;
          break;
        case "Email":
          if ("$FieldStart" == "Caption:"):
            echo "<B>$caption:</B>";
          else:
            echo $FieldStart;
          endif;
          if ($val):
?>
            <A HREF="mailto:<?echo $val;?>"><?echo $caption;?></A>
<?
          else:
            echo "&nbsp;";
          endif;
          echo $FieldEnd;
          break;
        default:
          if ("$FieldStart" == "Caption:"):
            echo "<B>$caption:</B>";
          else:
            echo $FieldStart;
          endif;
          echo $val;
          echo $FieldEnd;
          break;
      endswitch;
      $i++;
    endwhile;
    echo $RecEnd;
  endwhile;
  if ("$VIEW" == "table"):
    echo "</TABLE>\n";
  elseif ("$VIEW" == "list"):
    echo "</UL>";
  endif;
  if (!$HasLimit):
?>
    <P ALIGN="RIGHT">
    <A HREF="<?echo "$PHP_SELF?offset=$PAGESIZE";?>">Next <?echo $PAGESIZE;?>
    records</A>
    </P>
<?
  endif;
  FormStart();
  FormEnd("Generate code for SQL output");
  PrintFoot();
elseif ("$cmd" == "Generate code for SQL output"): // Code generation for given SQL
  PrintHead("Code for SQL output");
?>
<TABLE BGCOLOR="WHITE" WIDTH="100%" CELLPADDING=6>
<TR>
<TD>
<?
  $src = "<?\n" .
         "function NotAvailable(\$what = \"application\", \$reason = \"\") {\n" .
         "?>\n" .
         "  <HTML><HEAD><TITLE>Not available</TITLE></HEAD>" .
         "  <BODY><H1>Sorry,\n  <?echo \$what;?>\n  is not available</H1>\n" .
         "  <?\n  if (\$reason):\n    echo \"<P>Reason: <TT>\$reason</TT></P>\";\n" .
         "  endif;\n  ?></BODY></HTML>\n" .
         "<?\n" .
         "}\n\n" .
         "error_reporting(256); // set max level\n\n" .
         "\$offset = IntVal(\$offset);\n" .
         "\$DBHOST = \"$DBHOST\";\n" .
         "\$DBUSER = \"nobody\";\n" .
         "\$DBPASS = \"\";\n" .
         "\$DB = \"$DB\";\n" .
         "\$PAGESIZE = \"$PAGESIZE\";\n\n";
  $SQL = stripslashes($SQL);
  if (eregi("LIMIT", $SQL)):
    $src .= "\$SQL = \"SELECT $SQL\";\n\n";
    $PagedOutput = 0;
  else:
    $src .= "\$SQL = \"SELECT $SQL LIMIT \$offset,\$PAGESIZE\";\n\n";
    $PagedOutput = 1;
  endif;
  $src .= "if (!mysql_pconnect(\$DBHOST, \$DBUSER, \$DBPASS)):\n" .
         "  NotAvailable();\n" .
         "  exit;\n" .
         "endif;\n" .
         "if (!mysql_select_db(\$DB)):\n" .
         "  NotAvailable(\$DB, mysql_error());\n" .
         "  exit;\n" .
         "endif;\n" .
         "\$result = mysql_query(\$SQL);\n" .
         "if (!\$result):\n" .
         "  NotAvailable(\"Query result\", mysql_error());\n" .
         "  exit;\n" .
         "endif;\n" .
         "?>\n" .
         "<HTML>\n" .
         "<HEAD>\n" .
         "<TITLE>Query results</TITLE>\n" .
         "</HEAD>\n" .
         "<BODY>\n";
  if ("$VIEW" == "table"):
    $src .= "<TABLE WIDTH=\"100%\" BORDER=1 CELLPADDING=2 CELLSPACING=1>\n" .
         "<TR VALIGN=\"TOP\">\n";
    $i = 0;
    while ($i < count($FIELDS)):
      if ($FIELDS[$i] != "Dont" && $FIELDS[$i] != "Hidden"):
        $src .= "<TH>";
        $src .= $CAPTIONS[$i];
        $src .= "</TH>";
      endif;
      $i++;
    endwhile;
    $src .= "</TR>\n";
    $RecStart = "<TR VALIGN=\\\"TOP\\\">";
    $RecEnd = "</TR>";
    $FieldStart = "<TD>";
    $FieldEnd = "</TD>";
  elseif ("$VIEW" == "list"):
    $src .= "<UL>\n";
    $RecStart = "<LI>";
    $RecEnd = "</LI>";
    $FieldStart = "";
    $FieldEnd = ";";
  elseif ("$VIEW" == "records"):
    $RecStart = "";
    $RecEnd = "<HR>";
    $FieldStart = "Caption:";
    $FieldEnd = "<BR>";
  endif;
  $src .= "<?\n" .
         "while (\$row = mysql_fetch_array(\$result)):\n" .
         "  echo \"$RecStart\";\n";

  $i = 0;
  while ($i < count($FIELDS)):
      $field = $FIELDS[$i];
      $caption = $CAPTIONS[$i];
      $fieldname = $FIELDNAMES[$i];
      $src .= "  \$val = \$row[\"$fieldname\"];\n";
      switch ($field):
        case "Dont":
          break;
        case "Hidden":  // Don't use any separators here
          $src .= "?>\n  <INPUT TYPE=\"Hidden\" NAME=\"$caption\" " .
                  "VALUE=\"<?echo \$val;?>\">\n<?\n";
          break;
        case "Picture":
          $src .= "?>\n";
          if ("$FieldStart" == "Caption:"):
            $src .= "  <B>$caption:</B>";
          else:
            $src .= "  $FieldStart";
          endif;
          $src .= "<IMG SRC=\"<?echo \$val;?>\" BORDER=0 ALT=\"$caption\">$FieldEnd\n<?\n";
          break;
        case "URL":
          if ("$FieldStart" == "Caption:"):
            $src .= "  echo \"<B>$caption:</B>\";\n";
          else:
            $src .= "  echo \"$FieldStart\";\n";
          endif;
          $src .= "  if (\$val):\n" .
                  "?>\n    <A HREF=\"<?echo \$val;?>\">$caption</A>\n<?\n" .
                  "    else:\n" .
                  "      echo \"&nbsp;\";\n" .
                  "    endif;\n" .
                  "    echo \"$FieldEnd\";\n";
          break;
        case "Email":
          if ("$FieldStart" == "Caption:"):
            $src .= "  echo \"<B>$caption:</B>\";\n";
          else:
            $src .= "  echo \"$FieldStart\";\n";
          endif;
          $src .= "  if (\$val):\n" .
                  "?>\n" .
                  "    <A HREF=\"<?echo \$val;?>\">$caption</A>\n" .
                  "<?\n" .
                  "  else:\n" .
                  "    echo \"&nbsp;\";\n" .
                  "  endif;\n" .
                  "  echo \"$FieldEnd\";\n";
          break;
/*
*/
        default:
          if ("$FieldStart" == "Caption:"):
            $src .= "  echo \"<B>$caption:</B> ";
          else:
            $src .= "  echo \"$FieldStart";
          endif;
          $src .= "\$val" .
                  "$FieldEnd\";\n";
          break;
      endswitch;
      $i++;
    endwhile;
    $src .= "  echo \"$RecEnd\\n\";\n" .
            "endwhile;\n?>\n";
  if ("$VIEW" == "table"):
    $src .= "</TABLE>\n";
  elseif ("$VIEW" == "list"):
    $src .= "</UL>";
  endif;

  if ($PagedOutput):
    $src .= "<P ALIGN=\"RIGHT\">\n" .
            "<?\n" .
            "\$offset += \$PAGESIZE;\n" .
            "echo \"<A HREF=\\\"\$PHP_SELF?offset=\$offset\\\">Next " .
            "\$PAGSIZE records</A>\";\n" .
            "?>\n</P>\n";
  endif;

  $src .= "</BODY>\n" .
         "</HTML>\n" .
         "<?\n" .
         "mysql_free_result(\$result);\n" .
         "?>\n";
//  echo $src;
  highlight_string($src);
?>
</TD>
</TR>
</TABLE>
<FORM>
<TEXTAREA COLS=80 ROWS=40><?
echo HtmlSpecialChars($src);
?></TEXTAREA>
</FORM>
<?
  PrintFoot();
elseif ("$cmd" == "Select Table"): // What to do with table
  PrintHead("Choose action");
  echo "<H2>Add / Delete / Modify form</H2>\n";
  FormStart();
  FormEnd("Add/Edit records", 1);
  echo "<H2>Table display</H2>\n";  // Just process "SELECT * FROM table" SQL
  $SQL = "* FROM $TABLE";
  FormStart();
  FormEnd("Table View", 1);
  PrintFoot();
elseif ("$cmd" == "Add/Edit records"): // Add / change record form start
  if (!mysql_select_db($DB)):
    NotAvailable(__FILE__, __LINE__);
    exit;
  endif;
  if (!($fields = mysql_list_fields($DB, $TABLE))):
    NotAvailable(__FILE__, __LINE__);
    exit;
  endif;
  PrintHead("Add / Modify form generation ($TABLE)");
  FormStart();
?>
  <TABLE BORDER=1>
  <TR VALIGN="TOP"><TH>Name</TH><TH>Length</TH><TH>Flags</TH>
  <TH>Type</TH><TH>ID</TH><TH>Caption</TH><TH>Control</TH></TR>
<?
  $field_num = mysql_num_fields($fields);
  $i = 0;
  while ($i < $field_num):
    echo "<TR ALIGN=\"LEFT\" VALIGN=\"TOP\">";
    $name = mysql_field_name($fields, $i);
    $flags = mysql_field_flags($fields, $i);
    $len = mysql_field_len($fields, $i);
    $type = mysql_field_type($fields, $i);
    echo "<INPUT TYPE=\"Hidden\" NAME=\"FIELDS[]\" VALUE=\"$name\">";
    echo "<INPUT TYPE=\"Hidden\" NAME=\"FIELDNAMES[]\" VALUE=\"$name\">";
    echo "<TH>$name</TH>";
    echo "<TD>$len</TD>";
    echo "<TD>$flags</TD>";
    echo "<TD>$type</TD>";
    if (eregi("primary", $flags)):
      $SELECTED = "CHECKED";
    else:
      $SELECTED = "";
    endif;
    echo "<TD><INPUT TYPE=\"Radio\" NAME=\"IDFIELD\" VALUE=\"$name\" $SELECTED></TD>";
    echo "<TD><INPUT TYPE=\"Text\" NAME=\"CAPTIONS[]\" VALUE=\"$name\" SIZE=\"12\"></TD>";
    echo "<TD><SELECT NAME=\"CONTROLS[]\">";
    echo "<OPTION>Text\n"; // Text
    if (eregi("auto", $flags)):
      $SELECTED = "SELECTED";
    else:
      $SELECTED = "";
    endif;
    echo "<OPTION $SELECTED>Auto\n";
    echo "<OPTION>Preset\n";
    if (eregi("enum", $flags)):
      $SELECTED = "SELECTED";
    else:
      $SELECTED = "";
    endif;
    echo "<OPTION $SELECTED>Radio\n";
    if (eregi("blob", $type)):
      $SELECTED = "SELECTED";
    else:
      $SELECTED = "";
    endif;
    echo "<OPTION $SELECTED>Textarea\n";
    if (eregi("int", $type)):
      $SELECTED = "SELECTED";
    else:
      $SELECTED = "";
    endif;
    echo "<OPTION $SELECTED>Integer\n";
    if (eregi("float", $type)):
      $SELECTED = "SELECTED";
    else:
      $SELECTED = "";
    endif;
    echo "<OPTION $SELECTED>Real\n";
    if (eregi("(date)|(time)", $type)):
      $SELECTED = "SELECTED";
    else:
      $SELECTED = "";
    endif;
    echo "<OPTION $SELECTED>Now\n";
    echo "<OPTION>Checkbox\n";
    echo "<OPTION>Password\n";
    echo "<OPTION>Lookup\n";
    echo "<OPTION VALUE=\"Mysql\">Mysql function\n";
    echo "<OPTION VALUE=\"PHP\">PHP function\n";
    echo "</SELECT></TD>";
    echo "</TR>\n";
    $i++;
  endwhile;
?>
  </TABLE>
  <BR>
<?
  FormEnd("Next>");
  PrintFoot();
elseif ("$cmd" == "Next>"): // Add / change record form continue
  if (!mysql_select_db($DB)):
    NotAvailable(__FILE__, __LINE__);
    exit;
  endif;
  if (!($fields = mysql_list_fields($DB, $TABLE))):
    NotAvailable(__FILE__, __LINE__);
    exit;
  endif;
  PrintHead("Add / modify record form creation ($TABLE)");
  FormStart();
?>
  <TABLE BORDER=1>
  <TR VALIGN="TOP"><TH>Name</TH><TH>Length</TH><TH>Type</TH>
  <TH>Caption</TH><TH>Control</TH><TH>Property</TH></TR>
<?
  $field_num = mysql_num_fields($fields);
  $i = 0;
  while ($i < $field_num):
    $name = mysql_field_name($fields, $i);
    $flags = mysql_field_flags($fields, $i);
    $len = mysql_field_len($fields, $i);
    $type = mysql_field_type($fields, $i);
    if ($name == $IDFIELD):
?>
      <input type="Hidden" name="IDTYPE" value="<?echo $type;?>">
<?
    endif;
    echo "<TR ALIGN=\"LEFT\" ";
    if ($name == $IDFIELD):
      echo "BGCOLOR=\"White\" ";
    endif;
    echo "VALIGN=\"TOP\">";
    echo "<TH>$name</TH>";
    echo "<TD>$len</TD>";
    echo "<TD>$type</TD>";
    echo "<TD>".$CAPTIONS[$i]."</TD>";
    echo "<TD>".$CONTROLS[$i]."</TD>";
    echo "<TD>";
    switch ($CONTROLS[$i]):
      case "Auto":
      case "Now":
        echo "&nbsp;";
        break;
      case "Integer":
      case "Float":
      case "Password":
      case "Text":
        echo "Size:<INPUT TYPE=\"Text\" NAME=\"OPTIONS[$name]\" VALUE=\"$len\" SIZE=\"6\">";
        break;
      case "Textarea":
        echo "Cols/Row:<INPUT TYPE=\"Text\" NAME=\"OPTIONS[$name]\" VALUE=\"40/3\" SIZE=\"8\">";
        break;
      case "Preset":
        echo "PHP code:<B>&lt;?</B><INPUT TYPE=\"Text\" NAME=\"OPTIONS[$name]\" VALUE=\"echo 0;\" SIZE=\"16\"><B>?&gt;</B>";
        break;
      case "Checkbox":
        echo "Checked value:<INPUT TYPE=\"Text\" NAME=\"OPTIONS[$name]\" VALUE=\"Y\" SIZE=\"8\">";
        break;
      case "Radio":
        echo "Lbl1|Lbl2:<INPUT TYPE=\"Text\" NAME=\"OPTIONS[$name]\" VALUE=\"Yes|Now\" SIZE=\"16\">";
        break;
      case "Lookup":
        $tables = mysql_list_tables($DB);
        echo "Table: <SELECT NAME=\"OPTIONS[$name]\">";
        $tables_num = mysql_num_rows($tables);
        $j = 0;
        while ($j < $tables_num):
          $table_name = mysql_tablename($tables, $j);
          echo "<OPTION>$table_name\n";
          $j++;
        endwhile;
        mysql_free_result($tables);
        echo "</SELECT>";
        break;
      case "Mysql":
        echo "MySQL function:<INPUT TYPE=\"Text\" NAME=\"OPTIONS[$name]\" VALUE=\"func(%s)\">";
        break;
      case "PHP":
        echo "PHP function:<INPUT TYPE=\"Text\" NAME=\"OPTIONS[$name]\" VALUE=\"func(%s)\">";
        break;
    endswitch;
    echo "</TD>";
    echo "</TR>\n";
    $i++;
  endwhile;
?>
  </TABLE>
  <BR>
<?
  FormEnd("Next>>");
  PrintFoot();
elseif ("$cmd" == "Next>>"): // Add / change record form continue 2
  if (!mysql_select_db($DB)):
    NotAvailable(__FILE__, __LINE__);
    exit;
  endif;
  if (!($fields = mysql_list_fields($DB, $TABLE))):
    NotAvailable(__FILE__, __LINE__);
    exit;
  endif;
  PrintHead("Add / modify record form creation ($TABLE)");
  FormStart();
?>
  <TABLE BORDER=1>
  <TR VALIGN="TOP"><TH>Name</TH><TH>Length</TH><TH>Type</TH>
  <TH>Caption</TH><TH>Control</TH><TH>Property</TH><TH>Sub 1</TH>
  <TH>Sub 2</TH></TR>
<?
  $field_num = mysql_num_fields($fields);
  $i = 0;
  while ($i < $field_num):
    $name = mysql_field_name($fields, $i);
    $flags = mysql_field_flags($fields, $i);
    $len = mysql_field_len($fields, $i);
    $type = mysql_field_type($fields, $i);
    echo "<TR ALIGN=\"LEFT\" ";
    if ($name == $IDFIELD):
      echo "BGCOLOR=\"White\" ";
    endif;
    echo "VALIGN=\"TOP\">";
    echo "<TH>$name</TH>";
    echo "<TD>$len</TD>";
    echo "<TD>$type</TD>";
    echo "<TD>".$CAPTIONS[$i]."</TD>";
    echo "<TD>".$CONTROLS[$i]."</TD>";
    echo "<TD>".$OPTIONS[$name]."</TD>";
    echo "<TD>";
    switch ($CONTROLS[$i]):
      case "Integer":
      case "Float":
      case "Text":
        echo "Default:<INPUT TYPE=\"Text\" NAME=\"OPTIONS1[$name]\" SIZE=\"8\">";
        break;
      case "Textarea":
        echo "Default:<INPUT TYPE=\"Text\" NAME=\"OPTIONS1[$name]\" VALUE=\"\" SIZE=\"8\">";
        break;
      case "Checkbox":
        echo "Default:<INPUT TYPE=\"Checkbox\" NAME=\"OPTIONS1[$name]\" ";
        echo "VALUE=\"CHECKED\" SIZE=\"8\">";
        break;
      case "Radio":
        echo "Val1|Val2:<INPUT TYPE=\"Text\" NAME=\"OPTIONS1[$name]\" SIZE=\"16\">";
        break;
      case "Lookup":
          $lookup = mysql_list_fields($DB, $OPTIONS[$name]);
          echo "Key: <SELECT NAME=\"OPTIONS1[$name]\">";
          $lookup_num = mysql_num_fields($lookup);
          $j = 0;
          while ($j < $lookup_num):
            $key_name = mysql_field_name($lookup, $j);
            $key_flags = mysql_field_flags($lookup, $j);
            if (eregi("primary", $key_flags)):
              $SELECTED = "SELECTED";
            else:
              $SELECTED = "";
            endif;
            echo "<OPTION $SELECTED>$key_name\n";
            $j++;
          endwhile;
          mysql_free_result($lookup);
          echo "</SELECT>";
          break;
      default:
        echo "&nbsp;";
        break;
    endswitch;
    echo "</TD>";
    echo "<TD>";
    switch ($CONTROLS[$i]):
      case "Lookup":
          $lookup = mysql_list_fields($DB, $OPTIONS[$name]);
          echo "Display: <SELECT NAME=\"OPTIONS2[$name]\">";
          $lookup_num = mysql_num_fields($lookup);
          $j = 0;
          while ($j < $lookup_num):
            $val_name = mysql_field_name($lookup, $j);
            echo "<OPTION>$val_name\n";
            $j++;
          endwhile;
          mysql_free_result($lookup);
          echo "</SELECT>";
          break;
      default:
        echo "&nbsp;";
        break;
    endswitch;
    echo "</TD>";
    echo "</TR>\n";
    $i++;
  endwhile;
?>
  </TABLE>
  <BR>
  <INPUT TYPE="Submit" NAME="cmd" VALUE="Generate Add Form">
<?
  FormEnd("Generate Edit Form");
  PrintFoot();
elseif ("$cmd" == "Generate Add Form"): // Add record form code generation
  PrintHead("Code for record input");
?>
<TABLE BGCOLOR="WHITE" WIDTH="100%" CELLPADDING=6>
<TR>
<TD>
<?
  $src = "<?\n" .
    "function NotAvailable(\$what = \"application\", \$reason = \"\") {\n" .
    "?>\n" .
    "  <HTML><HEAD><TITLE>Not available</TITLE></HEAD>" .
    "  <BODY><H1>Sorry,\n  <?echo \$what;?>\n  is not available</H1>\n" .
    "  <?\n  if (\$reason):\n    echo \"<P>Reason: <TT>\$reason</TT></P>\";\n" .
    "  endif;\n?>\n  </BODY></HTML>\n" .
    "<?\n" .
    "}\n\n" .
    "error_reporting(256); // set max level\n\n" .
    "\$offset = IntVal(\$offset);\n" .
    "\$DBHOST = \"$DBHOST\";\n" .
    "\$DBUSER = \"nobody\";\n" .
    "\$DBPASS = \"\";\n" .
    "\$DB = \"$DB\";\n" .
    "if (!mysql_pconnect(\$DBHOST, \$DBUSER, \$DBPASS)):\n" .
    "  NotAvailable();\n" .
    "  exit;\n" .
    "endif;\n" .
    "if (!mysql_select_db(\$DB)):\n" .
    "  NotAvailable(\$DB, mysql_error());\n" .
    "  exit;\n" .
    "endif;\n" .
    "if (!\$Add):\n" .
    "?>\n" .
    "  <HTML>\n" .
    "  <HEAD><TITLE>New record ($TABLE)</TITLE></HEAD>\n" .
    "  <BODY>\n" .
    "  <TABLE>\n" . 
    "  <FORM ACTION=\"<?echo \$PHP_SELF;" .
    "?>\" METHOD=\"POST\">\n";
  $field_num = count($FIELDS);
  $i = 0;
  while ($i < $field_num):
    $name = $FIELDS[$i];
    $caption = $CAPTIONS[$i];
    $control = $CONTROLS[$i];
    $options = $OPTIONS[$name];
    $sub1 = $OPTIONS1[$name];
    $sub2 = $OPTIONS2[$name];
    switch ($control):
      case "Auto":
      case "Now":
        break;
      case "Integer":
      case "Float":
      case "PHP":
      case "Mysql":
      case "Text":
        $size = $options;
        $default = $sub1;
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>" .
                "<INPUT TYPE=\"Text\" NAME=\"_$name\" VALUE=\"$default\" " .
                "SIZE=\"$size\"></TD></TR>\n";
        break;
      case "Password":
        $size = $options;
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>" .
                "<INPUT TYPE=\"Password\" NAME=\"_$name" . "[]\" " .
                "SIZE=\"$size\"></TD></TR>\n" .
                "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>" .
                "<INPUT TYPE=\"Password\" NAME=\"_$name" . "[]\" " .
                "SIZE=\"$size\"></TD></TR>\n";
        break;
      case "Textarea":
        list($cols, $rows) = explode("/", $options);
        $default = $sub1;
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>" .
                "<TEXTAREA NAME=\"_$name\" " .
                "COLS=\"$cols\" ROWS=\"$rows\">$default</TEXTAREA></TD></TR>\n";
        break;
      case "Preset":
        $src .= "  <INPUT TYPE=\"Hidden\" NAME=\"_$name\" VALUE=\"<?$options" .
          "?>\">\n";
        break;
      case "Checkbox":
        $val = $options;
        $checked = $sub1;
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>" .
                "<INPUT TYPE=\"Checkbox\" NAME=\"_$name\" VALUE=\"$val\" " .
                "$checked></TD></TR>\n";
        break;
      case "Radio":
        $labels = explode("|", $options);
        $values = explode("|", $sub1);
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>\n";
        $j = 0;
        while ($j < count($values)):
          $label = $labels[$j];
          $val = $values[$j];
          $src .= "  $label:<INPUT TYPE=\"Radio\" NAME=\"_$name\" VALUE=\"$val\">\n";
          $j++;
        endwhile;
        $src .= "  </TD></TR>\n";
        break;
      case "Lookup":
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>\n" .
                "  <SELECT NAME=\"_$name\">\n" .
                "<?\n" .
                "  \$SQL = \"SELECT $sub1, $sub2 FROM $options\";\n" .
                "  \$result = mysql_query(\$SQL);\n" .
                "  while (\$row = mysql_fetch_array(\$result)):\n" .
                "    \$val = \$row[\"$sub1\"];\n" .
                "    \$label = \$row[\"$sub2\"];\n" .
                "    echo \"  <OPTION VALUE=\\\"\$val\\\">\$label\\n\";\n" .
                "  endwhile;\n" .
                "  mysql_free_result(\$result);\n" .
                "?>\n" .
                "  </SELECT>\n" .
                "  </TD></TR>";
        break;
    endswitch;
    $i++;
  endwhile;
  $src .= "  <TR><TD><INPUT TYPE=\"Submit\" NAME=\"Add\" VALUE=\"Add record\"></TD>" .
         "<TD><INPUT TYPE=\"Reset\"></TD></TR>\n" .
         "  </FORM>\n" .
         "  </TABLE>\n" .
         "  </BODY>\n" .
         "  </HTML>\n" .
         "<?\n" .
         "else:\n";
  $fields = mysql_list_fields($DB, $TABLE);
  $field_num = mysql_num_fields($fields);
  $i = 0;
  while ($i < $field_num):
    $name = mysql_field_name($fields, $i);
    $flags = mysql_field_flags($fields, $i);
    $len = mysql_field_len($fields, $i);
    $type = mysql_field_type($fields, $i);
    if ($CONTROLS[$i] != "Auto"):
      $numeric = 0;
      $blob = 0;
      switch ($type):
        case "int":
        case "float":
        case "double":
          $numeric = 1;
          break;
        case "blob":
          $blob = 1;
          break;
        default:
          break;
      endswitch;
      $field_names[] = $name;
      if ($CONTROLS[$i] == "Password"):
        $src .= "  if (\$_$name" . "[0] != \$_$name" . "[1]):\n" .
                "    // Passwords do not much!\n" .
                "    exit;\n" .
                "  else:\n" .
                "    \$_$name = \$_$name" . "[0];\n" .
                "  endif;\n";
      elseif ($CONTROLS[$i] == "PHP"):
        $func = sprintf($OPTIONS[$name], "\$_$name");
        $src .= "  \$_$name = $func;\n";
      endif;
      if ($numeric):
        $val = "\$_$name";
      else:
        $val = "'\$_$name'";
      endif;
      if ($CONTROLS[$i] == "Password"):
        $val = "password($val)";
      endif;
      if ($CONTROLS[$i] == "Mysql"):
        $val = sprintf($OPTIONS[$name], $val);
      endif;
      if ($CONTROLS[$i] == "Now"):
        $val = "now()";
      endif;
      $field_vals[] = $val;
    endif;
    $i++;
  endwhile;
  $SQL = "INSERT INTO $TABLE(" . implode(", ", $field_names) . ") \\n\" .\n" .
        "    \"VALUES (" . implode(", ", $field_vals) . ")";
  $src .= "  \$SQL = \"$SQL\";\n" .
         "  \$result = mysql_query(\$SQL);\n" .
         "  if (!\$result):\n" .
         "    NotAvailable(\"Query result\", mysql_error());\n" .
         "    exit;\n" .
         "  endif;\n" .
         "?>\n" .
         "  <HTML>\n" .
         "  <HEAD>\n" .
         "  <TITLE>Record added</TITLE>\n" .
         "  </HEAD>\n" .
         "  <BODY>\n" .
         "  <H1>Record added</H1>\n" .
         "  <A HREF=\"<?echo \$PHP_SELF;?>\">Add more</A>\n" .
         "  </BODY>\n" .
         "  </HTML>\n" .
         "<?\n" .
         "endif;\n";
  $src .= "?>";
  highlight_string($src);
?>
  </TD>
  </TR>
  </TABLE><BR>
  <FORM>
  <TEXTAREA COLS=80 ROWS=20 NAME="src"><?echo HtmlSpecialChars($src);?></TEXTAREA><BR>
  </FORM>
<?
  if (DEBUG):
    FormStart(); //for debug
    FormEnd(); //for debug
  endif;
  PrintFoot();
elseif ("$cmd" == "Generate Edit Form"): // Edit record form code generation
  PrintHead("Code for record update");
?>
<TABLE BGCOLOR="WHITE" WIDTH="100%" CELLPADDING=6>
<TR>
<TD>
<?
  $src = "<?\n" .
    "function NotAvailable(\$what = \"application\", \$reason = \"\") {\n" .
    "?>\n" .
    "  <HTML><HEAD><TITLE>Not available</TITLE></HEAD>\n" .
    "  <BODY><H1>Sorry,\n  <?echo \$what;?>\n  is not available</H1>\n" .
    "  <?\n  if (\$reason):\n    echo \"<P>Reason: <TT>\$reason</TT></P>\";\n" .
    "  endif;\n?>\n  </BODY></HTML>\n" .
    "<?\n" .
    "}\n\n" .
    "error_reporting(256); // set max level\n\n" .
    "\$offset = IntVal(\$offset);\n" .
    "\$DBHOST = \"$DBHOST\";\n" .
    "\$DBUSER = \"nobody\";\n" .
    "\$DBPASS = \"\";\n" .
    "\$DB = \"$DB\";\n" .
    "if (!mysql_pconnect(\$DBHOST, \$DBUSER, \$DBPASS)):\n" .
    "  NotAvailable();\n" .
    "  exit;\n" .
    "endif;\n" .
    "if (!mysql_select_db(\$DB)):\n" .
    "  NotAvailable(\$DB, mysql_error());\n" .
    "  exit;\n" .
    "endif;\n" .
    "if (!\$Update):\n";
  switch ($IDTYPE):
    case "int":
    case "float":
    case "real":
    case "double":
      $idval = "\$id";
      break;
    default:
      $idval = "'\$id'";
  endswitch;
  $src .= "  if (\"\$id\" == \"\"):\n" .
    "    \$SQL = \"SELECT * FROM $TABLE LIMIT 1\";\n" .
    "  else:\n" .
    "    \$SQL = \"SELECT * FROM $TABLE WHERE $IDFIELD = $idval\";\n" .
    "  endif;\n" .
    "  \$result = mysql_query(\$SQL);\n" .
    "  if (!\$result):\n" .
    "    NotAvailable(\$PHP_SELF, mysql_error());\n" .
    "    exit;\n" .
    "  endif;\n" .
    "  \$row = mysql_fetch_array(\$result);\n" .
    "  \$id = \$row[\"$IDFIELD\"];\n" .
    "  mysql_free_result(\$result);\n" .
    "?>\n" .
    "  <HTML>\n" .
    "  <HEAD><TITLE>Edit record ($TABLE)</TITLE></HEAD>\n" .
    "  <BODY>\n" .
    "  <TABLE>\n" . 
    "  <FORM ACTION=\"<?echo \$PHP_SELF;" .
    "?>\" METHOD=\"POST\">\n" .
    "  <INPUT TYPE=\"Hidden\" NAME=\"id\" VALUE=\"<?echo \$id;" .
    "?>\">\n";
  $field_num = count($FIELDS);
  $i = 0;
  while ($i < $field_num):
    $name = $FIELDS[$i];
    $caption = $CAPTIONS[$i];
    $control = $CONTROLS[$i];
    $options = $OPTIONS[$name];
    $sub1 = $OPTIONS1[$name];
    $sub2 = $OPTIONS2[$name];
    switch ($control):
      case "Auto":
      case "Now":
        break;
      case "Integer":
      case "Float":
      case "PHP":
      case "Mysql":
      case "Text":
        $size = $options;
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>" .
                "<INPUT TYPE=\"Text\" NAME=\"_$name\" " .
                "VALUE=\"<?echo \$row[\"$name\"];" . 
                "?>\" " .
                "SIZE=\"$size\"></TD></TR>\n";
        break;
      case "Password":
        $size = $options;
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>" .
                "<INPUT TYPE=\"Password\" NAME=\"_$name" . "[]\" " .
                "VALUE=\"<?echo \$row[\"$name\"];" .
                "?>\" " .
                "SIZE=\"$size\"></TD></TR>\n" .
                "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>Retype $caption:</TH><TD>" .
                "<INPUT TYPE=\"Password\" NAME=\"_$name" . "[]\" " .
                "VALUE=\"<?echo \$row[\"$name\"];" .
                "?>\" " .
                "SIZE=\"$size\"></TD></TR>\n";
        break;
      case "Textarea":
        list($cols, $rows) = explode("/", $options);
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>" .
                "<TEXTAREA NAME=\"_$name\" " .
                "COLS=\"$cols\" ROWS=\"$rows\"><?echo \$row[\"$name\"];" . 
                "?></TEXTAREA></TD></TR>\n";
        break;
      case "Preset":
        break;
      case "Checkbox":
        $val = $options;
        $checked = $sub1;
        $src .= "<?\n" .
          "  if (\$row[\"$name\"] == \"$val\"):\n" .
          "    \$checked = \"CHECKED\";\n" .
          "  else:\n" .
          "    \$checked = \"\";\n" .
          "  endif;\n" .
          "?>\n";
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>" .
                "<INPUT TYPE=\"Checkbox\" NAME=\"_$name\" VALUE=\"$val\" " .
                "<?echo \$checked;?>></TD></TR>\n";
        break;
      case "Radio":
        $labels = explode("|", $options);
        $values = explode("|", $sub1);
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>\n";
        $j = 0;
        while ($j < count($values)):
          $label = $labels[$j];
          $val = $values[$j];
          $src .= "<?\n" .
            "  if (\$row[\"$name\"] == \"$val\"):\n" .
            "    \$selected = \"SELECTED\";\n" .
            "  else:\n" .
            "    \$selected = \"\";\n" .
            "  endif;\n" .
            "?>\n" .
            "  $label:<INPUT TYPE=\"Radio\" NAME=\"_$name\" VALUE=\"$val\" " .
            "<?echo \$selected;?>>\n";
          $j++;
        endwhile;
        $src .= "  </TD></TR>\n";
        break;
      case "Lookup":
        $src .= "  <TR VALIGN=\"TOP\" ALIGN=\"LEFT\"><TH>$caption:</TH><TD>\n" .
                "  <SELECT NAME=\"_$name\">\n" .
                "<?\n" .
                "  \$SQL = \"SELECT $sub1, $sub2 FROM $options\";\n" .
                "  \$result = mysql_query(\$SQL);\n" .
                "  while (\$lookup = mysql_fetch_array(\$result)):\n" .
                "    \$val = \$lookup[\"$sub1\"];\n" .
                "    \$label = \$lookup[\"$sub2\"];\n" .
                "    if (\$row[\"$name\"] == \$val):\n" .
                "      \$selected = \"SELECTED\";\n" .
                "    else:\n" .
                "      \$selected = \"\";\n" .
                "    endif;\n" .
                "    echo \"  <OPTION VALUE=\\\"\$val\\\" \$selected>\$label\\n\";\n" .
                "  endwhile;\n" .
                "  mysql_free_result(\$result);\n" .
                "?>\n" .
                "  </SELECT>\n" .
                "  </TD></TR>";
        break;
/*
*/
    endswitch;
    $i++;
  endwhile;
  $src .= "  <TR><TD><INPUT TYPE=\"Submit\" NAME=\"Update\" VALUE=\"Update record\"></TD>" .
         "<TD><INPUT TYPE=\"Reset\" VALUE=\"Abort changes\">" .
         "</TD></TR>\n" .
         "  </FORM>\n" .
         "  <TR><TD>\n" .
         "<?\n" .
         "  \$SQL = \"SELECT $IDFIELD FROM $TABLE WHERE $IDFIELD < $idval ORDER BY $IDFIELD DESC LIMIT 1\";\n" .
         "  \$prev = mysql_query(\$SQL);\n" .
         "  if (mysql_num_rows(\$prev)):\n" .
         "    \$row = mysql_fetch_row(\$prev);\n" .
         "    \$previd = \$row[0];\n" .
         "?>\n" .
         "    <A HREF=\"<?echo \"\$PHP_SELF?id=\$previd\";" .
         "?>\">&lt;&lt;Previous record</A>\n" .
         "<?\n" .
         "  endif;\n" .
         "?>\n" .
         "  </TD>\n" .
         "  <TD ALIGN=\"RIGHT\">\n" .
         "<?\n" .
         "  \$SQL = \"SELECT $IDFIELD FROM $TABLE WHERE $IDFIELD > $idval ORDER BY $IDFIELD LIMIT 1\";\n" .
         "  \$next = mysql_query(\$SQL);\n" .
         "  if (mysql_num_rows(\$next)):\n" .
         "    \$row = mysql_fetch_row(\$next);\n" .
         "    \$nextid = \$row[0];\n" .
         "?>\n" .
         "    <A HREF=\"<?echo \"\$PHP_SELF?id=\$nextid\";" .
         "?>\">Next record&gt;&gt;</A>\n" .
         "<?\n" .
         "  endif;\n" .
         "?>\n" .
         "  </TD></TR>\n" .
         "  </TABLE>\n" .
         "  </BODY>\n" .
         "  </HTML>\n" .
         "<?\n" .
         "else:\n";
  $fields = mysql_list_fields($DB, $TABLE);
  $field_num = mysql_num_fields($fields);
  $i = 0;
  while ($i < $field_num):
    $name = mysql_field_name($fields, $i);
    $flags = mysql_field_flags($fields, $i);
    $len = mysql_field_len($fields, $i);
    $type = mysql_field_type($fields, $i);
    if ($CONTROLS[$i] != "Auto" && $CONTROLS[$i] != "Preset"):
      $numeric = 0;
      $blob = 0;
      switch ($type):
        case "int":
          $src .= "  \$_$name = IntVal(\$_$name);\n";
        case "float":
        case "double":
          if ($type != "int"):
            $src .= "  \$_$name = DoubleVal(\$_$name);\n";
          endif;
          $numeric = 1;
          break;
        case "blob":
          $blob = 1;
          break;
        default:
          break;
      endswitch;
      if ($CONTROLS[$i] == "Password"):
        $src .= "  if (\$_$name" . "[0] != \$_$name" . "[1]):\n" .
                "    // Passwords do not much!\n" .
                "    exit;\n" .
                "  else:\n" .
                "    \$_$name = \$_$name" . "[0];\n" .
                "  endif;\n";
      endif;
      if ($CONTROLS[$i] == "PHP"):
        $func = sprintf($OPTIONS[$name], "\$_$name");
        $src .= "  \$_$name = $func;\n";
      endif;
      if ($numeric):
        $val = "$name = \$_$name";
      else:
        $val = "$name = '\$_$name'";
      endif;
      if ($CONTROLS[$i] == "Password"):
        $val = "password($val)";
      endif;
      if ($CONTROLS[$i] == "Mysql"):
        $val = sprintf($OPTIONS[$name], $val);
      endif;
      $field_set[] = $val;
    endif;
    $i++;
  endwhile;
  $SQL = "UPDATE $TABLE SET " . implode(", ", $field_set) . " WHERE $IDFIELD = $idval";
  $src .= "  \$SQL = \"$SQL\";\n" .
         "  \$result = @mysql_query(\$SQL);\n" .
         "  if (!\$result):\n" .
         "    NotAvailable(\"Query result\", mysql_error());\n" .
         "    exit;\n" .
         "  endif;\n" .
         "?>\n" .
         "  <HTML>\n" .
         "  <HEAD>\n" .
         "  <TITLE>Record updated</TITLE>\n" .
         "  </HEAD>\n" .
         "  <BODY>\n" .
         "  <H1>Record updated</H1>\n" .
         "  <A HREF=\"<?echo \$PHP_SELF;?>\">What now?</A>\n" .
         "  </BODY>\n" .
         "  </HTML>\n" .
         "<?\n" .
         "endif;\n";
  $src .= "?>";
  highlight_string($src);
?>
  </TD>
  </TR>
  </TABLE><BR>
  <FORM>
  <TEXTAREA COLS=80 ROWS=20 NAME="src"><?echo HtmlSpecialChars($src);?></TEXTAREA><BR>
  </FORM>
<?
  if (DEBUG):
    FormStart();
    FormEnd();
  endif;
  PrintFoot();
endif;
?>