<?php
// Loading Images of type GIF,JPEG,PNG and BMP


/* Note: Gif only available with GD Lib ver < 1.6 */ 
function LoadGif ($imgname) { 
    $im = @imagecreatefromgif ($imgname); /* Attempt to open */ 
    if (!$im) { /* See if it failed */ 
        $im = imagecreate (150, 30); /* Create a blank image */ 
        $bgc = imagecolorallocate ($im, 255, 255, 255); 
        $tc = imagecolorallocate ($im, 0, 0, 0); 
        imagefilledrectangle ($im, 0, 0, 150, 30, $bgc); 
        /* Output an errmsg */ 
        imagestring ($im, 1, 5, 5, "Error loading $imgname", $tc); 
    } 
    return $im; 
} 

function LoadJpeg ($imgname) { 
    $im = @imagecreatefromjpeg ($imgname); /* Attempt to open */ 
    if (!$im) { /* See if it failed */ 
        $im  = imagecreate (150, 30); /* Create a blank image */ 
        $bgc = imagecolorallocate ($im, 255, 255, 255); 
        $tc  = imagecolorallocate ($im, 0, 0, 0); 
        imagefilledrectangle ($im, 0, 0, 150, 30, $bgc); 
        /* Output an errmsg */ 
        imagestring ($im, 1, 5, 5, "Error loading $imgname", $tc); 
    } 
    return $im; 
} 

function LoadPNG ($imgname) { 
    $im = @imagecreatefrompng ($imgname); /* Attempt to open */ 
    if (!$im) { /* See if it failed */ 
        $im  = imagecreate (150, 30); /* Create a blank image */ 
        $bgc = imagecolorallocate ($im, 255, 255, 255); 
        $tc  = imagecolorallocate ($im, 0, 0, 0); 
        imagefilledrectangle ($im, 0, 0, 150, 30, $bgc); 
        /* Output an errmsg */ 
        imagestring ($im, 1, 5, 5, "Error loading $imgname", $tc); 
    } 
    return $im; 
} 

/* Note: Gif only available with GD Lib ver >= 1.8 */ 
function LoadWBMP ($imgname) { 
    $im = @imagecreatefromwbmp ($imgname); /* Attempt to open */ 
    if (!$im) { /* See if it failed */ 
        $im  = imagecreate (20, 20); /* Create a blank image */ 
        $bgc = imagecolorallocate ($im, 255, 255, 255); 
        $tc  = imagecolorallocate ($im, 0, 0, 0); 
        imagefilledrectangle ($im, 0, 0, 10, 10, $bgc); 
        /* Output an errmsg */ 
        imagestring ($im, 1, 5, 5, "Error loading $imgname", $tc); 
    } 
    return $im; 
} 
?>